/*
 * This file is a part of the Jop-UI 
 * Copyright (C) 2009, 	Stefan Resch (e0425306@student.tuwien.ac.at)
 * 						Stefan Rottensteiner (e0425058@student.tuwien.ac.at)
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package com.jopdesign.jopui.core;

/**
 * Defines a standard theme for gui applications 
 */
public class Theme {

	/**
	 * Constant has the value 0xE2
	 */
	public static final int colorKey = 0xe2;
	
	/**
	 * Constant has the value 0xE0
	 */
	public static final int focusColor = 0xe0;//0x12;
	
	/**
	 * Constant has the value 0xFF
	 */
	public static final int mouseColor = 0xff;
	
	/**
	 * Constant has the value 0xFF 
	 */
	public static final int mouseColorLight = 0xFF;
	
	
	/**
	 * Constant has the value 0x00 
	 */
	public static final int mouseColorDark = 0x00;
	/**
	 * Constant has the value 0xDB
	 */
	public static final int colorLight = 0xdb;
	
	/**
	 * Constant has the value 0x6D 
	 */
	public static final int colorMiddle = 0x6d;
	
	/**
	 * Constant has the value 0x48 
	 */
	public static final int colorDark = 0x48;
	
	/**
	 * Constant has the value 0x07 
	 */
	public static final int colorBackground = 0x07;
	
	/* ****************************************************************** */
	// Label
	/* ****************************************************************** */
	/**
	 * Constant has the value 0xE2 
	 */
	public static final int colorLabelBackground = 0xe2;
	
	/**
	 * Constant has the value 0xE2 
	 */
	public static final int colorLabelBorder = 0xe2;
	
	/**
	 * Constant has the value 0xFF 
	 */
	public static final int colorLabelText = 0xff;
	
	/**
	 * Constant has the value 1 
	 */
	public static final int marginLabelLeft = 1;
	
	/**
	 * Constant has the value 1 
	 */
	public static final int marginLabelRight = 1;
	
	/**
	 * Constant has the value 0 
	 */
	public static final int marginLabelTop = 0;
	
	/**
	 * Constant has the value 0 
	 */
	public static final int marginLabelBottom = 0;
	
	/**
	 * Constant has the value 0
	 */
	public static final int halignLabel = Label.LEFT;
	
	/**
	 * Constant has the value 1
	 */
	public static final int valignLabel = Label.MIDDLE;
	
	/* ****************************************************************** */
	// Button
	/* ****************************************************************** */
	/**
	 * Constant has the value 0xFF 
	 */
	public static final int colorButtonText = 0xff;
	
	/**
	 * Constant has the value 0xDB 
	 */
	public static final int colorButtonLight = 0xdb;
	
	/**
	 * Constant has the value 0x48 
	 */
	public static final int colorButtonDark = 0x48;
	
	/**
	 * Constant has the value 0x6D 
	 */
	public static final int colorButtonBackground = 0x6d;
	
	/**
	 * Constant has the value 1 
	 */
	public static final int marginButtonLeft = 1;
	
	/**
	 * Constant has the value 1 
	 */
	public static final int marginButtonRight = 1;
	
	/**
	 * Constant has the value 0 
	 */
	public static final int marginButtonTop = 0;
	
	/**
	 * Constant has the value 0 
	 */
	public static final int marginButtonBottom = 0;
	
	/**
	 * Constant has the value 1 
	 */
	public static final int halignButton = Button.CENTER;
	
	/**
	 * Constant has the value 1 
	 */
	public static final int valignButton = Button.MIDDLE;
	
	/* ****************************************************************** */
	// TextField
	/* ****************************************************************** */
	/**
	 * Constant has the value 0x00 
	 */
	public static final int colorTextFieldText = 0x00;
	
	/**
	 * Constant has the value 0xDB 
	 */
	public static final int colorTextFieldLight = 0xdb;
	
	/**
	 * Constant has the value 0x48 
	 */
	public static final int colorTextFieldDark = 0x48;
	
	/**
	 * Constant has the value 0xFF 
	 */
	public static final int colorTextFieldBackground = 0xff;
	
	/**
	 * Constant has the value 2 
	 */
	public static final int marginTextFieldLeft = 2;
	
	/**
	 * Constant has the value 2 
	 */
	public static final int marginTextFieldRight = 2;
	
	/**
	 * Constant has the value 1 
	 */
	public static final int marginTextFieldTop = 1;
	
	/**
	 * Constant has the value 0 
	 */
	public static final int marginTextFieldBottom = 0;
	
	/**
	 * Constant has the value 0 
	 */
	public static final int halignTextField = TextField.LEFT;
	
	/**
	 * Constant has the value 1 
	 */
	public static final int valignTextField = TextField.MIDDLE;
	
	/* ****************************************************************** */
	// CheckBox
	/* ****************************************************************** */
	/**
	 * Constant has the value 0xFF 
	 */
	public static final int colorCheckBoxText = 0xff;
	
	/**
	 * Constant has the value 0xDB 
	 */
	public static final int colorCheckBoxLight = 0xdb;
	
	/**
	 * Constant has the value 0x48 
	 */
	public static final int colorCheckBoxDark = 0x48;
	
	/**
	 * Constant has the value 0xE2 
	 */
	public static final int colorCheckBoxBackground = 0xe2;
	
	/**
	 * Constant has the value 1 
	 */
	public static final int marginCheckBoxLeft = 1;
	
	/**
	 * Constant has the value 1 
	 */
	public static final int marginCheckBoxRight = 1;
	
	/**
	 * Constant has the value 1 
	 */
	public static final int marginCheckBoxTop = 1;
	
	/**
	 * Constant has the value 0 
	 */
	public static final int marginCheckBoxBottom = 0;
	
	/**
	 * Constant has the value 0 
	 */
	public static final int halignCheckBox = CheckBox.LEFT;
	
	/**
	 * Constant has the value 1
	 */
	public static final int valignCheckBox = CheckBox.MIDDLE;
	
	/**
	 * Constant has the value 0xFF 
	 */
	public static final int colorCheckBoxFill = 0xff;
	
	/**
	 * Constant has the value 0xE3 
	 */
	public static final int colorCheckBoxCheck = 0xe3;
	
	/**
	 * Constant has the value 12 
	 */
	public static final int colorCheckBoxSize = 12;
	
	/* ****************************************************************** */
	// Option
	/* ****************************************************************** */
	/**
	 * Constant has the value 0xFF 
	 */
	public static final int colorOptionText = 0xff;
	
	/**
	 * Constant has the value 0xDB 
	 */
	public static final int colorOptionLight = 0xdb;
	
	/**
	 * Constant has the value 0x48 
	 */
	public static final int colorOptionDark = 0x48;
	
	/**
	 * Constant has the value 0xE2 
	 */
	public static final int colorOptionBackground = 0xe2;
	
	/**
	 * Constant has the value 1 
	 */
	public static final int marginOptionLeft = 1;
	
	/**
	 * Constant has the value 1 
	 */
	public static final int marginOptionRight = 1;
	
	/**
	 * Constant has the value 1 
	 */
	public static final int marginOptionTop = 1;
	
	/**
	 * Constant has the value 0 
	 */
	public static final int marginOptionBottom = 0;
	
	/**
	 * Constant has the value 0
	 */
	public static final int halignOption = Option.LEFT;
	
	/**
	 * Constant has the value 1 
	 */
	public static final int valignOption = Option.MIDDLE;
	
	/**
	 * Constant has the value 0xFF 
	 */
	public static final int colorOptionFill = 0xff;
	
	/**
	 * Constant has the value 0xE3 
	 */
	public static final int colorOptionMark = 0xe3;
	
	/**
	 * Constant has the value 8 
	 */
	public static final int colorOptionSize = 8;

}
