package com.jopdesign.jopui.helper;

/**
 * Known ascii characters
 */
public interface AsciiTable {
	public static final int CHAR_NULL	= 0x00;
	public static final int CHAR_SOH	= 0x01;
	public static final int CHAR_STX	= 0x02;
	public static final int CHAR_ETX	= 0x03;
	public static final int CHAR_EOT	= 0x04;
	public static final int CHAR_ENQ	= 0x05;
	public static final int CHAR_ACK	= 0x06;
	public static final int CHAR_BEL	= 0x07;
	public static final int CHAR_BS		= 0x08;
	public static final int CHAR_TAB	= 0x09;
	public static final int CHAR_LF		= 0x0A;
	public static final int CHAR_VT		= 0x0B;
	public static final int CHAR_FF		= 0x0C;
	public static final int CHAR_CR		= 0x0D;
	public static final int CHAR_SO		= 0x0E;
	public static final int CHAR_SI		= 0x0F;
	public static final int CHAR_DLE	= 0x10;
	public static final int CHAR_DC1	= 0x11;
	public static final int CHAR_DC2	= 0x12;
	public static final int CHAR_DC3	= 0x13;
	public static final int CHAR_DC4	= 0x14;
	public static final int CHAR_NAK	= 0x15;
	public static final int CHAR_SYN	= 0x16;
	public static final int CHAR_ETB	= 0x17;
	public static final int CHAR_CAN	= 0x18;
	public static final int CHAR_EM		= 0x19;
	public static final int CHAR_SUB	= 0x1A;
	public static final int CHAR_ESC	= 0x1B;
	public static final int CHAR_FS		= 0x1C;
	public static final int CHAR_GS		= 0x1D;
	public static final int CHAR_RS		= 0x1E;
	public static final int CHAR_US		= 0x1F;
	public static final int CHAR_SPACE	= 0x20;
	public static final int CHAR_EXCLAMATION_MARK	= 0x21;
	public static final int CHAR_QUOTE	= 0x22;
	public static final int CHAR_NUMBER_SIGN	= 0x23;
	public static final int CHAR_DOLLAR	= 0x24;
	public static final int CHAR_PERCENT		= 0x25;
	public static final int CHAR_AND	= 0x26;
	public static final int CHAR_SEMI_QUOTE 		= 0x27;
	public static final int CHAR_LEFT_PARENTHESIS	= 0x28;
	public static final int CHAR_RIGHT_PARENTHESIS	= 0x29;
	public static final int CHAR_ASTERIX	= 0x2A;
	public static final int CHAR_PLUS	= 0x2B;
	public static final int CHAR_COMMA	= 0x2C;
	public static final int CHAR_MINUS	= 0x2D;
	public static final int CHAR_DOT	= 0x2E;
	public static final int CHAR_SLASH	= 0x2F;
	public static final int CHAR_0		= 0x30;
	public static final int CHAR_1		= 0x31;
	public static final int CHAR_2 		= 0x32;
	public static final int CHAR_3 		= 0x33;
	public static final int CHAR_4 		= 0x34;
	public static final int CHAR_5 		= 0x35;
	public static final int CHAR_6 		= 0x36;
	public static final int CHAR_7 		= 0x37;
	public static final int CHAR_8 		= 0x38;
	public static final int CHAR_9 		= 0x39;
	public static final int CHAR_COLON 	= 0x3A;
	public static final int CHAR_SEMICOLON	= 0x3B;
	public static final int CHAR_LESS 	= 0x3C;
	public static final int CHAR_EQUALS = 0x3D;
	public static final int CHAR_GREATER 	= 0x3E;
	public static final int CHAR_QUESTION_MARK	= 0x3F;
	public static final int CHAR_AT 	= 0x40;
	public static final int CHAR_UC_A 	= 0x41;
	public static final int CHAR_UC_B 	= 0x42;
	public static final int CHAR_UC_C 	= 0x43;
	public static final int CHAR_UC_D 	= 0x44;
	public static final int CHAR_UC_E 	= 0x45;
	public static final int CHAR_UC_F 	= 0x46;
	public static final int CHAR_UC_G 	= 0x47;
	public static final int CHAR_UC_H 	= 0x48;
	public static final int CHAR_UC_I 	= 0x49;
	public static final int CHAR_UC_J 	= 0x4A;
	public static final int CHAR_UC_K 	= 0x4B;
	public static final int CHAR_UC_L 	= 0x4C;
	public static final int CHAR_UC_M 	= 0x4D;
	public static final int CHAR_UC_N 	= 0x4E;
	public static final int CHAR_UC_O 	= 0x4F;
	public static final int CHAR_UC_P 	= 0x50;
	public static final int CHAR_UC_Q 	= 0x51;
	public static final int CHAR_UC_R 	= 0x52;
	public static final int CHAR_UC_S 	= 0x53;
	public static final int CHAR_UC_T 	= 0x54;
	public static final int CHAR_UC_U 	= 0x55;
	public static final int CHAR_UC_V 	= 0x56;
	public static final int CHAR_UC_W 	= 0x57;
	public static final int CHAR_UC_X 	= 0x58;
	public static final int CHAR_UC_Y 	= 0x59;
	public static final int CHAR_UC_Z 	= 0x5A;
	public static final int CHAR_LEFT_BRACKET	= 0x5B;
	public static final int CHAR_BACKSLASH 		= 0x5C;
	public static final int CHAR_RIGHT_BRACKET 	= 0x5D;
	public static final int CHAR_CIRCUMFLEX 	= 0x5E;
	public static final int CHAR_UNDERSCORE 	= 0x5F;
	public static final int CHAR_ACCENT = 0x60;
	public static final int CHAR_LC_A 	= 0x61;
	public static final int CHAR_LC_B 	= 0x62;
	public static final int CHAR_LC_C 	= 0x63;
	public static final int CHAR_LC_D 	= 0x64;
	public static final int CHAR_LC_E 	= 0x65;
	public static final int CHAR_LC_F 	= 0x66;
	public static final int CHAR_LC_G 	= 0x67;
	public static final int CHAR_LC_H 	= 0x68;
	public static final int CHAR_LC_I 	= 0x69;
	public static final int CHAR_LC_J 	= 0x6A;
	public static final int CHAR_LC_K 	= 0x6B;
	public static final int CHAR_LC_L 	= 0x6C;
	public static final int CHAR_LC_M 	= 0x6D;
	public static final int CHAR_LC_N 	= 0x6E;
	public static final int CHAR_LC_O 	= 0x6F;
	public static final int CHAR_LC_P 	= 0x70;
	public static final int CHAR_LC_Q 	= 0x71;
	public static final int CHAR_LC_R 	= 0x72;
	public static final int CHAR_LC_S 	= 0x73;
	public static final int CHAR_LC_T 	= 0x74;
	public static final int CHAR_LC_U 	= 0x75;
	public static final int CHAR_LC_V 	= 0x76;
	public static final int CHAR_LC_W 	= 0x77;
	public static final int CHAR_LC_X 	= 0x78;
	public static final int CHAR_LC_Y 	= 0x79;
	public static final int CHAR_LC_Z 	= 0x7A;
	public static final int CHAR_LEFT_BRACE		= 0x7B;
	public static final int CHAR_PIPE	= 0x7C;
	public static final int CHAR_RIGHT_BRACE  	= 0x7D;
	public static final int CHAR_TILDE 	= 0x7E;
	public static final int CHAR_DEL 	= 0x7F;
}
