/*
  This file is part of JOP, the Java Optimized Processor
    see <http://www.jopdesign.com/>

  Copyright (C) 2009, Jens Kager, Fritz Praus

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package fat;

import java.io.IOException;

public abstract class FileStream {

	protected FatLowLevel fatlowlevel;

	public static final int STREAM_TYPE_MMC=0;
	public static final int STREAM_TYPE_NAND=1;

	public FileStream(int streamtype) throws IOException {

		switch (streamtype) {
			case STREAM_TYPE_MMC:
				fatlowlevel = new FatMmc();
				break;
			case STREAM_TYPE_NAND:
				fatlowlevel = new FatNand();
				break;
			default:
				throw new IOException("Streamtype must be MMC/SD or NAND flash");
		}
	}
}
