/*
 * This file is part of JOP, the Java Optimized Processor
 *   see <http://www.jopdesign.com/>
 *
 * Copyright (C) 2010, Stefan Hepp (stefan@stefant.org).
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

/**
 * The {@code common} package provides a set of classes and utilities for common tasks such as
 * <ul>
 * <li>Loading and processing configuration files and commandline options, including common options</li>
 * <li>Loading, modifying and generating java class files</li>
 * <li>Exchanging java classes and custom annotations between various tools in memory</li>
 * <li>Analyzing the java classes and bytecode, by providing a class hierarchy, callgraphs and control flow graphs</li>
 * <li>Logging, help-text generation, BCEL extensions, common exception classes, ... </li>
 * </ul>
 *
 *  
 */
package com.jopdesign.common;