/*
  This file is part of JOP, the Java Optimized Processor
    see <http://www.jopdesign.com/>

  Copyright (C) 2011, Martin Schberl (martin@jopdesign.com)

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package com.jopdesign.tools;

/**
 * Generate comon:com.jopdesign.sys.JopConfig, which contains
 * configuration constants for the JOP runtime.<br/>
 * Usage: GenJopConfig CONSTANT1=value1 CONSTANT2=value ...
 * <br/> Currently all values have to be booleans.
 * 
 * @author Benedikt Huber <benedikt.huber@gmail.com>
 */
public class GenJopConfig {

	public static void main(String[] argv) {
		System.out.println("/* AUTOGENERATED by com.jopdesign.tools.GenJopConfig */");
		System.out.println("package com.jopdesign.sys;");
		System.out.println("public class Config {");
		for(String arg : argv) {
			System.out.println("public static final boolean "+arg+";");
		}
		System.out.println("}");
	}
}
